#define __AVR_ATmega2560__
#define F_CPU 16000000UL
#define DISPLAY PORTF

#include <avr/io.h>
#include <util/delay.h>
#include <stdbool.h>
#include "lib/util.h"
#include "lib/7segment.h"
#include "lib/7segment_4digits.h"

void main() {
    prog_7segment_4digit();
}

void prog_7segment() {
    DDRF  = 0b11111111;
    DDRK  = 0b00000000;
    PORTK = 0b00000001; // enable pull-up resistor

    uint8_t val = 0;

    set_display(&PORTF, val, false);

    while(1) {
        loop_until_bit_is_clear(PINK, PINK0);

        if (val >= 9) {
            val = 0xff; // will overflow to 0 when incremented
        }

        set_display(&PORTF, ++val, true);

        // debounce
        _delay_ms(200);

        loop_until_bit_is_set(PINK, PINK0);
        set_display(&PORTF, val, false);
    }
}

void prog_7segment_4digit() {
    DDRF  = 0b11111111;
    DDRK  = 0b00001111;
    PORTK = 0b10000000; // set pull-up

    float num = 0.0f;
    bool running = false;
    bool pressed = false;

    while(1) {
        show_float(num);
        float sleep_time = update_display();

        if (!pressed && bit_is_clear(PINK, PINK7)) {
            running = !running;
            pressed = true;
        } else if (pressed && bit_is_set(PINK, PINK7)) {
            pressed = false;
        }

        if (running) {
            num += sleep_time / 1000.0f / 1000.0f;
            if (num >= 10000) num = 0.0f;
        }
    }
}
